"use strict";
// Copyright (c) NumFOCUS.
// Distributed under the terms of the Modified BSD License.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
const apputils_1 = require("@jupyterlab/apputils");
const widgetExports = __importStar(require("./datagrid"));
const version_1 = require("./version");
const EXTENSION_ID = 'ipydatagrid:plugin';
/**
 * The datagrid plugin.
 */
const datagridPlugin = {
    id: EXTENSION_ID,
    requires: [base_1.IJupyterWidgetRegistry],
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    optional: [apputils_1.IThemeManager],
    activate: activateWidgetExtension,
    autoStart: true,
};
exports.default = datagridPlugin;
/**
 * Activate the widget extension.
 */
function activateWidgetExtension(app, registry, themeManager) {
    // Exporting a patched DataGridView widget which handles dynamic theme changes
    class DataGridView extends widgetExports.DataGridView {
        initialize(parameters) {
            if ((themeManager === null || themeManager === void 0 ? void 0 : themeManager.theme) != null) {
                this.isLightTheme = themeManager.isLight(themeManager.theme);
            }
            super.initialize(parameters);
        }
        render() {
            return super.render().then(() => {
                if (themeManager) {
                    themeManager.themeChanged.connect(this.onThemeChanged, this);
                }
            });
        }
        onThemeChanged() {
            if ((themeManager === null || themeManager === void 0 ? void 0 : themeManager.theme) != null) {
                this.isLightTheme = themeManager.isLight(themeManager.theme);
            }
            this.updateGridStyle();
            this.default_renderer.onThemeChanged();
            for (const key in this.renderers) {
                this.renderers[key].onThemeChanged();
            }
        }
        remove() {
            if (themeManager) {
                themeManager.themeChanged.disconnect(this.onThemeChanged, this);
            }
            return super.remove();
        }
    }
    registry.registerWidget({
        name: version_1.MODULE_NAME,
        version: version_1.MODULE_VERSION,
        exports: Object.assign(Object.assign({}, widgetExports), { DataGridView }),
    });
}
//# sourceMappingURL=plugin.js.map