import { DataGrid } from '@lumino/datagrid';
import { IMessageHandler, Message } from '@lumino/messaging';
import { FeatherGrid } from './feathergrid';
export declare class StreamingFeatherGrid extends FeatherGrid {
    constructor(options: StreamingFeatherGrid.IOptions);
    messageHook(handler: IMessageHandler, msg: Message): boolean;
    tick(): void;
    private pullDataImpl;
    private _requestData;
    private _pullData;
}
export declare namespace StreamingFeatherGrid {
    interface IOptions extends DataGrid.IOptions {
        /**
         * The function for requesting data to the back-end.
         */
        requestData: (r1: number, r2: number, c1: number, c2: number) => void;
        /**
         * Delay for debouncing data requests.
         */
        debounceDelay: number;
    }
}
