import { WidgetModel, WidgetView } from '@jupyter-widgets/base';
import { CellRenderer } from '@lumino/datagrid';
export declare class VegaExprModel extends WidgetModel {
    defaults(): {
        _model_name: string;
        _model_module: any;
        _model_module_version: any;
        value: string;
    };
    initialize(attributes: any, options: any): void;
    process(config: CellRenderer.CellConfig, defaultValue: any): any;
    _processRegex(match: string, data: string): string;
    /**
     * Augments transpiled JS code output from vega with
     * datamodel calls for condition validation.
     * @param parsedValue JS code (string) generated from a vega expression
     */
    private _augmentExpression;
    private updateFunction;
    static model_name: string;
    static model_module: any;
    static model_module_version: any;
    static view_name: string;
    static view_module: any;
    static view_module_version: any;
    _codegen: any;
    _function: any;
}
export declare class VegaExprView extends WidgetView {
    process(config: CellRenderer.CellConfig, defaultValue: any): any;
    model: VegaExprModel;
}
export interface ParsedVegaExpr {
    /**
     * A JavaScript storing literal describing
     * the converted vega expression
     */
    code: string;
}
